Special-Purpose Label Terminology
RFC 9017
Loa Andersson
Bronze Dragon Consulting
loa@pi.nu
Kireeti Kompella
Juniper Networks
kireeti@juniper.net
Adrian Farrel
Old Dog Consulting
adrian@olddog.co.uk
April 2021
MPLS
Extended Special-Purpose Label
Base Special-Purpose Label
Reserved Label
Entropy Label Indicator
This document discusses and recommends terminology that may be used when MPLS Special-Purpose Labels (SPLs) are specified and documented.
This document applies that terminology change to the relevant IANA registry and also clarifies the use of the Entropy Label Indicator (7) when immediately preceded by the Extension Label (15).
This document updates RFCs 3032 and 7274.
Introduction
RFC 7274 [RFC7274] made some changes to the terminology used for MPLS Special-Purpose Labels but did not define consistent terminology.
One thing that RFC 7274 did was to deprecate the use of the term "reserved labels" when describing a range of labels allocated from a registry maintained by IANA. The term "Reserved" in such a registry means "set aside, not to be used", but that range of labels was available for allocation according to the policies set out in that registry. The name "Special-Purpose Labels" was introduced in RFC 7274 in place of the previous term, and the abbreviation "SPL" was recommended.
At the time of writing the first draft version of this document, the IETF was in the process of allocating the very first SPLs from the Extended SPL (eSPL) range [RFC8595]. This document discusses and recommends terminology and abbreviations to be used when talking about and documenting Special-Purpose Labels.
This document updates RFC 3032 [RFC3032] and RFC 7274 [RFC7274] in that it changes the terminology for both Base SPLs (previously referred to simply as "Special-Purpose Labels") and Extended SPLs.
This document applies that terminology change to the relevant IANA registry and also clarifies the use of the Entropy Label Indicator (7) when immediately preceded by the Extension Label (15).
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Background
Two sets of SPLs are defined for use in MPLS:
- The range 0-15 (Base Special-Purpose Labels (bSPLs) as described in this document) is specified in RFC 3032 [RFC3032].
- The range 0-1048575 of eSPLs is specified in RFC 7274 [RFC7274].
  - The values 0-15 have been reserved and are never to be allocated.
  - The values 16-239 are available for allocation.
  - The values 240-255 are for experimental use.
  - The values 256-1048575 are currently not available for allocation. A Standards Track RFC would be needed to change this rule, and that RFC would need to define the ranges that are made available for allocation and the registration policy for those ranges.
GMPLS Special-Purpose Labels
Note that IANA maintains a registry that is called "Special-Purpose Generalized Label Values". Labels in that registry have special meaning when present in certain signaling objects, are 32 bits long, and are not to be confused with MPLS forwarding-plane labels. This document does not make any changes to the GMPLS registry or to how labels from that registry are described.
Terminology and Abbreviations
Prior to the publication of this document, IANA maintained a name space for "Special-Purpose Multiprotocol Label Switching (MPLS) Label Values" code points [SPL-NAME-SPACE]. Within this name space, there are two registries. One was called the "Special-Purpose MPLS Label Values" registry [bSPL]. The other was called the "Extended Special-Purpose MPLS Label Values" registry [eSPL].
The difference in the name of the name space and the first registry is only that the MPLS abbreviation is expanded. This document makes no change to the name of the name space itself (i.e., "Special-Purpose Multiprotocol Label Switching (MPLS) Label Values"). This document changes the name of the first registry to "Base Special-Purpose MPLS Label Values" but leaves the name of the latter registry unchanged as "Extended Special-Purpose MPLS Label Values".
The following conventions will be used in specifications and when talking about SPLs.
- Collectively, the two (unrelated) ranges (0-15 and 16-1048575) are known as "Special-Purpose Labels" (SPLs).
- SPLs from the range 0-15 are called "Base Special-Purpose Labels" (bSPLs).
- SPLs from the range 16-1048575 are called "Extended Special-Purpose Labels" (eSPLs). (Note that the reserved values 0-15 from the "Extended Special-Purpose MPLS Label Values" registry do not need a name, as they are not available for allocation and MUST NOT be used.)
- The combination of the Extension Label (XL) (value 15, which is a bSPL and is also called the "xSPL") and an eSPL is called a "Composite Special-Purpose Label" (cSPL).
This results in label stacks such as the examples shown in Figures 1 and 2.
Example of Label Stack

                0                                  31
                |     MPLS Label Stack entry        |
                +--------+--------+--------+--------+
                |     MPLS Label Stack entry        |
                +--------+--------+--------+--------+
      bSPL      |             Base SPL              |
                +--------+--------+--------+--------+
                |  MPLS Label Stack entry (cont.)   |
Example of Label Stack

                0                                  31
                |     MPLS Label Stack entry        |
                +--------+--------+--------+--------+
                |     MPLS Label Stack entry        |
                +--------+--------+--------+--------+
      xSPL      |       Extension Label (XL)        | <--+
                +--------+--------+--------+--------+    |--- cSPL
      eSPL      |           Extended SPL            | <--+
                +--------+--------+--------+--------+
                |  MPLS Label Stack entry (cont.)   |
Clarification on Handling of the Entropy Label Indicator
Section 3.1 of [RFC7274] contains two paragraphs that describe the handling of the Entropy Label Indicator (label 7). These paragraphs have introduced some confusion about whether the Entropy Label Indicator can be present when immediately preceded by the Extension Label. This document updates [RFC7274] by replacing those paragraphs as follows.
OLD
Values 0-15 of the "Extended Special-Purpose MPLS Label Values" registry are set aside as reserved. Furthermore, values 0-6 and 8-15 MUST NOT appear in the data plane following an XL; an LSR processing a packet with an XL at the top of the label stack followed by a label with value 0-6 or 8-15 MUST drop the packet.
Label 7 (when received) retains its meaning as Entropy Label Indicator (ELI) whether a regular special-purpose label or an ESPL; this is because of backwards compatibility with existing implemented and deployed code and hardware that looks for the ELI without verifying if the previous label is XL or not. However, when an LSR inserts an entropy label, it MUST insert the ELI as a regular special-purpose label, not as an ESPL.
NEW
Values 0-15 of the "Extended Special-Purpose MPLS Label Values" registry are set aside as reserved. Furthermore, an implementation MUST NOT place a label with a value in the range 0-15 in the label stack immediately following an XL; an LSR processing a packet with an XL at the top of the label stack immediately followed by a label with a value in the range 0-15 MUST drop the packet.
When inspecting a label stack to find an Entropy Label Indicator (ELI -- label 7), a preexisting implementation may fail to inspect the previous label and thus not notice that it is an XL. Such systems can continue to process the entropy information and forward the packet when the previous label is an XL without causing harm. However, the packet will be dropped when the XL reaches the top of the stack at another LSR.
END
Security Considerations
This document describes the terminology to be used when describing and specifying the use of SPLs. It does not affect forwarding in the MPLS data plane, nor does it have any effect on how Label Switched Paths are established by an MPLS control plane or by a centralized controller.
This document does not aim to describe existing implementations of SPLs or potential vulnerabilities of SPLs.
IANA Considerations
IANA has changed the name of the registry once called "Special-Purpose MPLS Label Values" to now be called "Base Special-Purpose MPLS Label Values" [bSPL].
IANA has also updated the "Base Special-Purpose MPLS Label Values" registry by changing the description for value 15 from "Extension Label" to "Extension Label (XL)" and also adding this document as a reference.
Updated Entry for Value 15 in the "Base Special-Purpose MPLS Label Values" Registry
Value | Description | Reference
15 | Extension Label (XL) | RFC 7274, RFC 9017
References
Normative References
[SPL-NAME-SPACE]

Special-Purpose Multiprotocol Label Switching (MPLS) Label Values
IANA
[bSPL]

Base Special-Purpose MPLS Label Values
IANA
[eSPL]

Extended Special-Purpose MPLS Label Values
IANA
Informative References
[RFC7274]
[RFC8595]
[RFC3032]
[RFC2119]
[RFC8174]
Acknowledgements
We would like to thank the Routing Directorate reviewer, Eric Gray, for a detailed, careful, and insightful review, and Tom Petch for pointing out several issues of clarity.
Contributors
The following individual contributed text to this document:
Stewart Bryant
Futurewei Technologies Inc.
stewart.bryant@gmail.com